-- Laser for boss mode
freeslot("MT_LASERKBOSS", "S_LASERBOSS")
states[S_LASERBOSS] = {SPR_THOK, A, -1, nil, 0, 0, S_LASERBOSS}
mobjinfo[MT_LASERKBOSS] = {
	spawnstate = S_LASERBOSS,
	spawnhealth = 1000,
	radius = 30*FRACUNIT,
	height = 30*FRACUNIT,
	flags = MF_MISSILE|MF_NOGRAVITY,
}

addHook("MobjThinker", function(mo)
	local colors = {
		SKINCOLOR_POPCORN,
		SKINCOLOR_SKUNK,
		SKINCOLOR_BRICK,
		SKINCOLOR_SCARLET,
		SKINCOLOR_PISTACHIO,
		SKINCOLOR_MOSS,
		SKINCOLOR_DREAM,
		SKINCOLOR_OLIVE,
		SKINCOLOR_NAVY,
		SKINCOLOR_THUNDER,
		SKINCOLOR_FUCHSIA,
		SKINCOLOR_LILAC
	}
	
	if not (leveltime%15) then mo.color = colors[P_RandomRange(1, #colors)] end
	P_InstaThrust(mo, mo.angle, 50*FRACUNIT)
end, MT_LASERKBOSS)