local function hellRain()
	if (leveltime > 8*TICRATE)
		local possiblePlayers = {}

		for p in players.iterate
			if validP(p) then table.insert(possiblePlayers, p.mo) end
		end

		if #possiblePlayers and not (leveltime%10)
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			
			local possibleHazards = {
				MT_BLUESPRING, 
				MT_YELLOWSPRING,
				MT_REDSPRING,
				MT_GRAYSPRING,
				MT_BLUEDIAG,
				MT_YELLOWDIAG,
				MT_REDDIAG,
				MT_BANANA, 
				MT_EGGMANITEM,
				MT_SSMINE_SHIELD,
				MT_ORBINAUT,
				MT_JAWZ_DUD,
				MT_FALLINGROCK,
				MT_BLUECRAWLA,
				MT_REDCRAWLA,
				MT_GFZFISH,
				MT_JETTBOMBER,
				MT_JETTGUNNER,
				MT_CRAWLACOMMANDER,
				MT_SKIM,
				MT_POPUPTURRET,
				MT_ROBOHOOD,
				MT_FACESTABBER,
				MT_EGGGUARD,
				MT_GSNAPPER,
				MT_CYBRAKDEMON_FLAMEREST,
				MT_TORNADO,
				MT_RANDOMITEM
			}
			
			local shit = P_SpawnMobj(tmo.x+P_RandomRange(-2000, 2000)<<FRACBITS, tmo.y+P_RandomRange(-2000, 2000)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, possibleHazards[P_RandomRange(1, #possibleHazards)])
			shit.angle = P_RandomRange(0, 360)*ANG1
			shit.target = tmo
			shit.color = tmo.color
			
			if shit.type == MT_TORNADO
				shit.fuse = 30*TICRATE
				shit.nopull = true
			end
			
			if shit.type == MT_RANDOMITEM
				shit.flags = $ & ~MF_NOGRAVITY & ~MF_NOCLIPHEIGHT & ~MF_SLIDEME
			end
		end
	end
	
	if (leveltime == 8*TICRATE) then
		S_ChangeMusic("CRUSHR")
		showMusicCredit()
	end

	-- End Terms
	local playersLeft = {}
	for p in players.iterate
		if p.boxdata.out == false
			table.insert(playersLeft, p)
		end
	end
	
	server.ended = $ or false
	if #playersLeft <= 1 and server.ended == false
		for p in players.iterate
			if p.boxdata.out == true
				p.marescore = p.boxdata.survivaltime or 0
			else
				p.marescore = 69420
			end
		end
		
		BX_EndBattle()
		server.ended = true
	end
end

local function hellDie(p, inf, src)
	if p.mo and p.mo.valid and p.boxdata
		if p.boxdata.out == true then return true end
		
		if p.kartstuff[k_bumper] < 1
			print(p.name.." was defeated.")
			p.boxdata.out = true
			p.boxdata.survivaltime = G_TicsToSeconds(leveltime-8*TICRATE)
			BX_ExplodeAndRespawn(p)
			K_PlayLossSound(p.mo)
		end
	end
end

Box.Gamemodes[GM_HELLRAIN] = {
	name = "Hellrain",
	hint = "Be the last one standing!",
	bumpers = 4,
	thinker = hellRain,
	damagefunc = hellDie,
	spinfunc = hellDie,
	squishfunc = hellDie,
	explodefunc = hellDie
}