local function sinks()
	if not (leveltime%165)
		for p in players.iterate
			if validP(p)
				p.kartstuff[k_itemtype] = 16
				p.kartstuff[k_itemamount] = 1
			end
		end
	end
	
	if (leveltime == 8*TICRATE) then
		S_ChangeMusic("KTBOSS")
		showMusicCredit()
	end

	-- End Terms
	local playersLeft = {}
	for p in players.iterate
		if p.boxdata.out == false
			table.insert(playersLeft, p)
		end
	end
	
	server.ended = $ or false
	if #playersLeft <= 1 and server.ended == false
		for p in players.iterate
			if p.boxdata.out == true
				p.marescore = p.boxdata.survivaltime or 0
			else
				p.marescore = 69420
			end
		end
		
		BX_EndBattle()
		server.ended = true
	end
end

local function sinkDie(p, inf, src)
	if p.mo and p.mo.valid and p.boxdata
		if p.boxdata.out == true then return true end
		
		print(p.name.." was hit by a sink.")
		p.boxdata.out = true
		p.boxdata.survivaltime = G_TicsToSeconds(leveltime-8*TICRATE)
		BX_ExplodeAndRespawn(p)
		K_PlayLossSound(p.mo)
	end
end

Box.Gamemodes[GM_SINKSTRIKE] = {
	name = "Sink Strike",
	hint = "Be the last one standing!",
	noBumpers = true,
	thinker = sinks,
	damagefunc = sinkDie,
	spinfunc = sinkDie,
	squishfunc = sinkDie,
	explodefunc = sinkDie
}